function d = pderiv_setdepth(d, n, l)

if n == 0
    d = pderiv_v(d);
    return
end

if isobject(d)
    if nargin < 3
        l = size(d.d,1);
    end
    assert(l == size(d.d,1));
    d.d = pderiv_setdepth(d.d, n-1, l);
else
    d = pderiv(d, pderiv_setdepth(zeros([l size(d)]), n-1, l));
end
