function [d n] = pderiv_shiftdepth(d, n, l)

if n < 0
    if isobject(d)
        [d.d n] = pderiv_shiftdepth(d.d, n);
        if n
            d = d.v;
            n = n + 1;
        end
    end
elseif n > 1
    if isobject(d)
        if nargin < 3
            l = size(d.d,1);
        end
        assert(l == size(d.d,1));
        [d.d n] = pderiv_shiftdepth(d.d, n, l);
    else
        d = pderiv_setdepth(d, n, l);
        n = 0;
    end
end
