function d = reshape(d, varargin)
%PDERIV/RESHAPE	Change pderiv array size.

if nargin == 2
    d.v = reshape(d.v, varargin{1});
    d.d = reshape(d.d, [size(d.d,1) varargin{1}]);
else
    d.v = reshape(d.v, varargin{:});
    d.d = reshape(d.d, size(d.d,1), varargin{:});
end
