function pderiv_test()

pv = [1 3 5 8];
pn = length(pv);
p = param_deriv(pv);
assert(length(p) == pn);

pd = p(1:pn);

for i = 1:pn
    assert(pd(i).d0 == pv(i));
    for j = 1:pn
        assert(pd(i).d1(j) == (i == j));
        pd2(i,j) = p(i) .* pd(j);
        assert(pd2(i,j).d0 == pv(i)*pv(j));
    end
    assert(pd2(i,i).d1(i) == 2*pv(i));
end

ab = p(3) .^ [2 p([1 2])] + 1;
assert(all(abs(ab.d0 - [26 6 126]) < 1e-10));
assert(all(abs(ab.d1(1) - [0 5*log(5) 0]) < 1e-10));
assert(all(abs(ab.d1(3) - [10 1 75]) < 1e-10));
assert(all(ab.d1(4) == 0));
