function d = pderiv_setsub(d, i, v)

if isobject(v)
    [d v] = pderiv_all(d, v);
    d.v(i{:}) = v.v;
    if isscalar(v.v)
        v.d = repmat(v.d, [1 size(d.v(i{:}))]);
    end
    d.d = pderiv_setsub(d.d, {':' i{:}}, v.d);
elseif isobject(d)
    d.v(i{:}) = v;
    d.d = pderiv_setsub(d.d, {':' i{:}}, 0);
else
    d(i{:}) = v;
end
